#ifndef __CPU_H
#define __CPU_H

#include "types.h"

void init_cpu();

uint32_t cpu_mem_read32(uintptr_t addr);
void cpu_mem_write32(uintptr_t addr, uint32_t data);

/*
  invalidate all cache lines corresponding to a memory buffer

  @param buf const void * pointer to the memory buffer
  @param size size_t size of the memory buffer
 */
void cpu_dcache_invalidate(const void *buf, size_t size);

#endif
